/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SortRuleRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SortRuleRequest{}

// SortRuleRequest struct for SortRuleRequest
type SortRuleRequest struct {
	Column    *string `json:"column,omitempty"`
	Direction *string `json:"direction,omitempty"`
}

// NewSortRuleRequest instantiates a new SortRuleRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSortRuleRequest() *SortRuleRequest {
	this := SortRuleRequest{}
	return &this
}

// NewSortRuleRequestWithDefaults instantiates a new SortRuleRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSortRuleRequestWithDefaults() *SortRuleRequest {
	this := SortRuleRequest{}
	return &this
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *SortRuleRequest) GetColumn() string {
	if o == nil || IsNil(o.Column) {
		var ret string
		return ret
	}
	return *o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SortRuleRequest) GetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *SortRuleRequest) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given string and assigns it to the Column field.
func (o *SortRuleRequest) SetColumn(v string) {
	o.Column = &v
}

// GetDirection returns the Direction field value if set, zero value otherwise.
func (o *SortRuleRequest) GetDirection() string {
	if o == nil || IsNil(o.Direction) {
		var ret string
		return ret
	}
	return *o.Direction
}

// GetDirectionOk returns a tuple with the Direction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SortRuleRequest) GetDirectionOk() (*string, bool) {
	if o == nil || IsNil(o.Direction) {
		return nil, false
	}
	return o.Direction, true
}

// HasDirection returns a boolean if a field has been set.
func (o *SortRuleRequest) HasDirection() bool {
	if o != nil && !IsNil(o.Direction) {
		return true
	}

	return false
}

// SetDirection gets a reference to the given string and assigns it to the Direction field.
func (o *SortRuleRequest) SetDirection(v string) {
	o.Direction = &v
}

func (o SortRuleRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SortRuleRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.Direction) {
		toSerialize["direction"] = o.Direction
	}
	return toSerialize, nil
}

type NullableSortRuleRequest struct {
	value *SortRuleRequest
	isSet bool
}

func (v NullableSortRuleRequest) Get() *SortRuleRequest {
	return v.value
}

func (v *NullableSortRuleRequest) Set(val *SortRuleRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSortRuleRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSortRuleRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSortRuleRequest(val *SortRuleRequest) *NullableSortRuleRequest {
	return &NullableSortRuleRequest{value: val, isSet: true}
}

func (v NullableSortRuleRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSortRuleRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
